#!/usr/bin/env python
# -*- coding: utf-8 -*-
import sys
import os
import signal
import argparse
from detallePuerto import *
from ventanaPrincipal import *
from tabla import *
from PyQt4 import QtCore, QtGui
from gestionSwitch import *
import sqlite3
from PyQt4.QtGui import *
from PyQt4.QtCore import *

sys.path.append('/home/dario/TFG')
from gestionVlanSNMP import *
try:
    _fromUtf8 = QtCore.QString.fromUtf8
except AttributeError:
    def _fromUtf8(s):
        return s

try:
    _encoding = QtGui.QApplication.UnicodeUTF8
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig, _encoding)
except AttributeError:
    def _translate(context, text, disambig):
        return QtGui.QApplication.translate(context, text, disambig)




class Gestion(QtGui.QMainWindow):
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self,parent)
        self.ui = GestionSwitch()
        self.ui.setupUi(self)
        QtCore.QObject.connect(self.ui.guardar, QtCore.SIGNAL(QtCore.QString.fromUtf8("clicked()")), self.guarda_cambios)
        QtCore.QObject.connect(self.ui.cancelar, QtCore.SIGNAL(QtCore.QString.fromUtf8("clicked()")), self.cancela_cambios)
    def cancela_cambios(self):
        con = sqlite3.connect("/home/dario/TFG/basedatos.db")
        cursorObj = con.cursor()
        #Realiza la consulta para obtener el estado de los puertos
        sql_consulta = "SELECT * FROM configuracion"
        cursorObj.execute(sql_consulta)
        row = cursorObj.fetchone()
        self.ui.ip.setText(_translate("Form", str(row[0]), None))
        self.ui.num_puertos.setText(_translate("Form", str(row[1]), None))
        self.ui.vlan_restringida.setText(_translate("Form", str(row[3]), None))
        self.ui.vlan_conocidos.setText(_translate("Form", str(row[5]), None))
        self.ui.vlan_registrados.setText(_translate("Form", str(row[4]), None))
        self.ui.comunidad_lectura.setText(_translate("Form", str(row[6]), None))
        self.ui.comunidad_escritura.setText(_translate("Form", str(row[7]), None))
        con.close()
    def guarda_cambios(self):
        
        con = sqlite3.connect("/home/dario/TFG/basedatos.db")
        cursorObj = con.cursor()
        #Realiza la consulta para obtener el estado de los puertos
        sql_consulta = "SELECT num_puertos FROM configuracion"
        cursorObj.execute(sql_consulta)
        row = cursorObj.fetchone()
        msg = QMessageBox()
        msg.setIcon(QMessageBox.Information)
       
        msg.setWindowTitle("Cambio realizado")
        puertos = str(self.ui.num_puertos.text())
        ip = str(self.ui.ip.text())
        vlan_restringida = str(self.ui.vlan_restringida.text())
        vlan_registrados = str(self.ui.vlan_registrados.text())
        vlan_conocidos = str(self.ui.vlan_conocidos.text())
        comunidad_escritura = str(self.ui.comunidad_escritura.text())    
        comunidad_lectura = str(self.ui.comunidad_lectura.text())
        sql_update = "UPDATE configuracion SET ip ='" + ip + "', num_puertos =" + puertos +", vlan_restringida=" + vlan_restringida + ", vlan_registrados=" + vlan_registrados + ", vlan_conocidos=" + vlan_conocidos + ", comunidad_escritura='" + comunidad_escritura + "',comunidad_lectura ='" + comunidad_lectura + "'"
        cursorObj.execute(sql_update)
        con.commit()
        if int(puertos) > int(row[0]):
                
            for i in range((int(row[0])+1),(int(puertos)+1)):
                sql_insert = "INSERT INTO switch VALUES(" + str(i) + ",0,null,null,0,300)"
                cursorObj.execute(sql_insert)
                con.commit()
                #con.close()
        elif int(puertos) < int(row[0]):
            sql_delete= "DELETE FROM switch WHERE puerto > " + puertos
            cursorObj.execute(sql_delete)
            con.commit()
            
                
        con.close()
       
        texto = """<html><head/><body><p><span>Cambios realizados con éxito<br/></span></p></body></html>"""
        msg.setText(_translate("TextBox", texto, None))
        msg.exec_()
        self.close()
       
#####################################################################################
#                               Clase Aplicacion                                    #
#####################################################################################
# Clase que implementa la ventana principal de la aplicación                        #
#####################################################################################
class Aplicacion (QtGui.QMainWindow):
    #Contructor de la clase
    def __init__(self, parent=None):
        QtGui.QWidget.__init__(self,parent)
        self.ui = Ui_MainWindow()
        self.ui.setupUi(self)
        #Asocia las señales del menu con sus respectivas acciones
        QtCore.QObject.connect(self.ui.actionPuertos, QtCore.SIGNAL(QtCore.QString.fromUtf8("activated()")), self.muestra_puertos)
        QtCore.QObject.connect(self.ui.actionActualizar, QtCore.SIGNAL(QtCore.QString.fromUtf8("activated()")), self.actualiza_interfaz)
        QtCore.QObject.connect(self.ui.actionGestionar, QtCore.SIGNAL(QtCore.QString.fromUtf8("activated()")), self.muestra_gestion)
        QtCore.QObject.connect(self.ui.actionInicializar, QtCore.SIGNAL(QtCore.QString.fromUtf8("activated()")), self.inicializaBD)
    
    def closeEvent(self, event):
        con = sqlite3.connect("/home/dario/TFG/basedatos.db")
        cursorObj = con.cursor()
        sql_update = "UPDATE configuracion SET pid_proceso = null" 
        cursorObj.execute(sql_update)
        con.commit()
        con.close()
    def inicializaBD(self):
        obj = gestionVlanSNMP()
        n = obj.importa_datos()
        msg = QMessageBox()
        msg.setIcon(QMessageBox.Information)
        msg.setWindowTitle("Base de datos inicializada")
        if n!=0:
            texto = """<html><head/><body><p><span>Cambio realizado.<br/>La base de datos estaba desactualizada.<br/></span></p></body></html>"""
            msg.setText(_translate("TextBox", texto, None))
            msg.exec_()
        else:
            texto = """<html><head/><body><p><span>La base de datos estaba actualizada.<br/>No se ha realizado ningún cambio.</span></p></body></html>"""
            msg.setText(_translate("TextBox", texto, None))
            msg.exec_()
        self.actualiza_interfaz()
        return
    def muestra_puertos(self):
        QtGui.QWidget.__init__(self)
        #Accede a la base de datos para obtener el número de puertos
        con = sqlite3.connect("/home/dario/TFG/basedatos.db")
        cursorObj = con.cursor()
        #Realiza la consulta para obtener el estado de los puertos
        sql_consulta = "SELECT * FROM configuracion"
        cursorObj.execute(sql_consulta)
        row = cursorObj.fetchone()
        num_puertos = row[1]
        print num_puertos
        self.table = QtGui.QTableWidget()
        self.table.setRowCount(num_puertos)
        self.table.setColumnCount(5)
        self.table.setGeometry(0, 0, 505, 500)
        self.table.setWindowTitle("Estado del Switch")
        self.table.setItem(1, 0, QtGui.QTableWidgetItem("Hola"))
        self.table.verticalHeader().hide()
        self.table.setHorizontalHeaderLabels(QString("Puerto;Estado;Usuario;Direccion MAC;VLAN").split(";"))
        header = self.table.horizontalHeader()
        header.setResizeMode(QHeaderView.ResizeToContents)
        header.setStretchLastSection(True)
        
        sql_consulta = "SELECT puerto, estado, login, mac, vlan FROM switch"
        cursorObj.execute(sql_consulta)
        rows = cursorObj.fetchall()
        i = 0
        for fila in rows:
            self.table.setItem(i, 0, QtGui.QTableWidgetItem(str(fila[0])))
            if fila[1] == 2:
                self.table.setItem(i, 1, QtGui.QTableWidgetItem("Desconectado"))
            else:
                self.table.setItem(i, 1, QtGui.QTableWidgetItem("Conectado"))
                self.table.setItem(i, 2, QtGui.QTableWidgetItem(str(fila[2])))
                self.table.setItem(i, 3, QtGui.QTableWidgetItem(str(fila[3])))
            if fila[4] == row[3]:
                item = "Restringida(" + str(row[3]) + ")"
                self.table.setItem(i, 4, QtGui.QTableWidgetItem(item))
            elif fila[4] == row[5]:
                item = "Conocidos(" + str(row[5]) + ")"
                self.table.setItem(i, 4, QtGui.QTableWidgetItem(item))
            elif fila[4] == row[4]:
                item = "Registrados(" + str(row[4]) + ")"
                self.table.setItem(i, 4, QtGui.QTableWidgetItem(item))
            else:
                 self.table.setItem(i, 4, QtGui.QTableWidgetItem(str(fila[4])))
            i = i + 1
        con.close()
        self.table.show()
        
    def muestra_gestion(self):
        window = Gestion(self)
        window.show()
   
    #Método encargado de actualizar el estado de la interfaz
    def actualiza_interfaz(self):
        con = sqlite3.connect("/home/dario/TFG/basedatos.db")
        cursorObj = con.cursor()
        #Realiza la consulta para obtener el estado de los puertos
        sql_consulta = "SELECT * FROM switch" 
        cursorObj.execute(sql_consulta)
        rows = cursorObj.fetchall()
        con.close()
        #Evalúa el resultado de la consulta
        for row in rows :
            #Para el caso del puerto 1
            if row[0] == 1:
                #Si el puerto está conectado entra
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_1.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_1.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_1.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_1.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_1.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_1.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_1.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 2
            elif row[0] == 2:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_2.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_2.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_2.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_2.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_2.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_2.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_2.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 2
            elif row[0] == 3:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_3.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_3.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_3.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_3.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_3.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_3.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_3.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 4
            elif row[0] == 4:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_4.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_4.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_4.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_4.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_4.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_4.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_4.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 5
            elif row[0] == 5:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_5.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_5.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_5.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_5.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_5.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_5.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_5.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 6
            elif row[0] == 6:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_6.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_6.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_6.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_6.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_6.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_6.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_6.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 7
            elif row[0] == 7:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_7.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_7.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_7.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_7.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_7.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_7.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_7.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
            #Para el puerto 8
            elif row[0] == 8:
                if row[1] == 1:
                    #Si se encuentra en la VLAN 300 pone el cable de color amarillo
                    if row[5] == 300:
                        self.ui.line_8.setStyleSheet(_fromUtf8("background-color: rgb(255, 255, 0);\n"
                        "color: rgb(255, 255, 0);"))
                        texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                        Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                        #Muestra la información 
                        self.ui.datos_8.setText(_translate("MainWindow", texto, None))
                    else:
                        #Si pertenece a cualquier otra VLAN, cambia el color a amarillo
                        self.ui.line_8.setStyleSheet(_fromUtf8("background-color: rgb(0, 255, 0);\n"
                        "color: rgb(0, 255, 0);"))
                        #Si no hay usuario registrado muestra el usuario como Desconocido
                        if row[2] == None:
                            texto = """<html><head/><body><p><span style=\" font-weight:600;\">Usuario: </span>
                            Desconocido</p><p>""" + str(row[3]) + "</p></body></html>"
                            
                            #Muestra la información
                            self.ui.datos_8.setText(_translate("MainWindow", texto, None))
                        else:
                            texto ="""<html><head/><body><p><span style=\" font-weight:600;\">Usuario:
                            </span>""" + str(row[2]) + "</p><p>" + str(row[3]) + "</p></body></html>"
                            self.ui.datos_8.setText(_translate("MainWindow", texto, None))
                            
                #Si el puerto está desconectado entra
                else:
                    #Pinta la línea de gris
                    self.ui.line_8.setStyleSheet(_fromUtf8("background-color: rgb(173, 173, 173);\n"
                    "color: rgb(173, 173, 173);"))
                    #Muestra la información
                    self.ui.datos_8.setText(_translate("MainWindow", """<html><head/><body><p>Desconectado
                    </p><p><br/></p></body></html>""", None))
        

def main():
    
    parser = argparse.ArgumentParser()
    parser.add_argument('--force', action='store_true')
    args = (parser.parse_args())
    
    app =QtGui.QApplication(sys.argv)
    myapp = Aplicacion()
    #Función para manejar la recepción de una señal que indica que se ha cambiado el estado de un puerto
    def receive_signal(*args):
        
        myapp.actualiza_interfaz()
        return
    signal.signal(signal.SIGUSR1, receive_signal)
    pid = os.getpid()
    con = sqlite3.connect("/home/dario/TFG/basedatos.db")
    cursorObj = con.cursor()
    
    #Conprueba si la opción --force esta activa y en ese caso pone a null el campo pid para que se pueda ejecutar la aplicación
    if args.force:  
        cursorObj.execute("UPDATE configuracion SET pid_proceso=null")
        con.commit()
        
    sql_consulta = "SELECT pid_proceso FROM configuracion"
    cursorObj.execute(sql_consulta)
    row = cursorObj.fetchone()
    
    
    
    if row[0] is not None:
        msg = QMessageBox()
        msg.setIcon(QMessageBox.Information)
        texto = """<html><head/><body><p><span>El programa ya está abierto<br/></span></p></body></html>"""
        msg.setText(_translate("TextBox", texto, None))
        msg.exec_()
        return
    sql_update = "UPDATE configuracion SET pid_proceso = " + str(pid)
    cursorObj.execute(sql_update)
    con.commit()
    con.close()
    timer = QTimer()
    timer.start(500)  
    timer.timeout.connect(lambda: None)
    myapp.actualiza_interfaz()
    myapp.show()
    sys.exit(app.exec_())

if __name__ =="__main__":
    main()
    
    
